\ Umbilical Forth kernel code           

((
Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

First Release: 29/04/91

Changes:	See RELEASE.DOC for full details
))

\ user variables                                   sfp 28/06/90

HEX
000 user s0                     \ reset value of data stack
002 user r0                     \ reset value of return stack
006 user base                   \ number conversion base
007 user out                    \ output counter
((
008 user span                   \ if i/p buffer used
014 user pad                    \ start of scratch string buff.
))
\ constants                                        Jon 20/06/89

hex

0 CONSTANT 0

\ stack manipulation - depth                       sfp 28/06/90

: DEPTH         \ -- n ; returns target stack depth
  S0 @ SP@ - 2- 2/  ;

\ (.")                                          sfpJon 20/06/89
hex

: even          \ addr -- addr' ; make number even
  dup 1 and                             \ odd ?
  if  1+  endif  ;                      \ yes, step on 1

: (.")          \ -- ; displays in-line data
  r> count 2dup + even >r type  ;
\ u.            *** NOT BASE SENSITIVE ***         Jon 20/06/89
decimal

: u.            \ u -- ; simple print utility
  0                                     \ -- u 0 ; start counter
  begin  1+                             \ increment counter
         swap 0 10 um/mod               \ -- n rem quot
         rot over 0=                    \ -- rem quot n flag
  until                                 \ until next digit 0
  swap                                  \ -- dign..dig1 n 0
  do  ascii 0 + emit  loop              \ display character
  ."  "  ;                              \ display space

\ u.            *** BASE SENSITIVE ***             Jon 20/06/89
((
: u.            \ u -- ; simple print utility
  0                                     \ -- u 0 ; start counter
  begin  1+                             \ increment counter
         swap 0 base c@ um/mod          \ -- n rem quot
         rot over 0=                    \ -- rem quot n flag
  until                                 \ until next digit 0
  swap                                  \ -- dign..dig1 n 0
  do  dup 9 > if  7 +  endif            \ allows for A..F
      ascii 0 + emit                    \ display character
  loop                                  \
  ."  "  ;                              \ display space
))
\ .                                                sfp 13/09/89

: .             \ n -- ; display character
  dup 0<                                \ if negative
  if  ." -" abs  endif                  \  add leading '-'
  u.  ;                                 \ then print it

((
: .             \ n --
  .-cmnd>h send-message  ;
))
\ cold                                             Jon 20/06/89
hex

L: STRT         ] COLD [        	\ cold start word

: startup	\ -- ;
  (init)				\ initialisation
  STRT @ execute			\ run startup word
;

: cold
  run-umbilical
;