((

	PAGES.FTH

	J Lee :- 26/6/90

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This file contains code for both symbol pages and target pages.

))



only forth also c-c definitions
decimal

decimal  all from-file ..\pagetab.fth




\ >Page-Table Page-Chunk! Page-Chunk@ Blank-Page-Chunks .. J Lee -- 25/06/90
\


: >Page-Table	( page# -- page-record ; return address of page# record )
	/Page-Record * Page-Table +  ;


: Page-Chunk!	( seg page# -- )
	>page-table Page.Chunk !(g)  ;


: Page-Chunk@	( page# -- seg )
	>page-table Page.Chunk @(g)  ;


: Blank-Page-Chunks	( -- ; set all page chunks to 0 i.e. not present )
	#pages 0
	?Do
		0 i page-chunk!
	Loop  ;




\ Page.Flags definitions .. J Lee -- 17/4/91
\


\ maximum 8 flags permitted
1 constant data-page-bit		\ bit 0 := 1 data, 0 Code
2 constant emulator-bit                 \ bit 1 := 1 emulator, 0 disk


: Data-Page?	( page# -- t/f )
  data-page-bit swap >page-table page.flags test-bit(g) 0<>  ;


: Mark-Data-Page  ( page# -- )
  data-page-bit swap >page-table page.flags set-bit(g)  ;


: In-Emulator?  ( page# -- t/f )
  emulator-bit swap >page-table page.flags test-bit(g) 0<>  ;


: Mark-Emulator  ( page# -- )
  emulator-bit swap >page-table page.flags set-bit(g)  ;




\ Curr-Page Curr-Page@ Curr-Page! Curr-Page-Chunk .. J Lee -- 28/06/90
\


: Curr-Page@	( -- page# )
	Curr-Page @(g)  ;


: Curr-Page!	( page# -- )
	Curr-Page !(g)  ;


: Curr-Page-Chunk	( -- page-chunk )
	curr-page@ page-chunk@  ;




\ @(p) !(p) +!(p) c@(p) c!(p) 2!(p) 2@(p) .. J Lee -- 24/06/90
\


: @(p)	( offset -- n )
	curr-page-chunk  swap  @l  ;


: !(p)	( n offset -- )
	curr-page-chunk  swap  !l  ;                  


: +!(p)	( n offset -- )
	dup @(p)  rot +  swap !(p)  ; 


: c@(p)	( offset -- c )
	curr-page-chunk  swap  c@l  ;


: c!(p)	( c offset -- )
	curr-page-chunk  swap  c!l  ;


: 2!(p)	( d offset -- )
	curr-page-chunk swap 2!l  ;


: 2@(p)	( offset -- d )
	curr-page-chunk swap 2@l  ;




\ Code-Page@ Data-Page@ With-Code With-Data .. J Lee -- 18/10/90
\


: Code-Page@	( -- target-page# )
	curr-page@ >page-table page.id @(g)  ;

: Data-Page@	( -- target-page# )
	curr-page@ >page-table page.id @(g)  ;


: With-Code	( -- )
        voc-seg @(g) page-voc-seg !(p)
	curr-code-page @(g) curr-page!
        page-voc-seg @(p) voc-seg !(g)  ;


: With-Data	( -- )
        voc-seg @(g) page-voc-seg !(p)
	curr-data-page @(g) curr-page!
        page-voc-seg @(p) voc-seg !(g)  ;

	


\ Init-Page .. J Lee -- 26/06/90
\


: Init-Page	( page# -- )
	dup curr-page!			\ set page# as current page
	init-chunk			\ get an initialised chunk
	dup rot page-chunk!		\ set chunk segment in page table
	>Chunk-Link off(v)			\ set all chunk links to zero (end)
	<Chunk-Link off(v)			\
	dup >Voc-Link(s) Curr->Voc-Link(s) 2!(v)  \ initialise forward voc chain
	Latest-Chunk !(v)  		\ created chunk := latest chunk
        voc-seg @(g) dup voc-seg(p) !(p)
        page-voc-seg !(p)  ;




\ ^<Voc-Link(s) ^>Voc-Link ^Curr->Voc-Link(s) .. J Lee -- 28/06/90
\


: ^<Voc-Link(s)	( -- seg offset ; return the page 32-bit address )
	curr-page-chunk <voc-link(s)  ;


: ^>Voc-Link(s)	( -- seg offset ; return the page 32-bit address )
	curr-page-chunk >voc-link(s)  ;


: ^Curr->Voc-Link(s)	( -- seg offset ; return 32-bit page address )
	curr-page-chunk curr->voc-link(s)  ;









