((

	SYM-PRIM.FTH

	J Lee :- 25/1/91

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This code performs primitive operations.

	All of the '(s)' memory operators use an implicit segment in their
	operation. This segment is know as the 'CURRENT-CHUNK' and can be found
	by inspecting the 'LATEST-CHUNK' of the 'DEFINITIONS(S)' vocabulary.

))




only forth also c-c definitions
decimal




\ Erase(s)l Cmove(s)l Cmove>(s)l .. J Lee -- 02/07/90
\


Code Cmove(s)l	( seg source destination len -- )
\	bx pop			        \ get length
	cx, bx mov		        \ set length
	ax, si mov   dx, di mov	        \ save Forth registers
	di pop   si pop   es pop        \ get parameters
	l$2 jcxz

l$1:
	rep es: movsb

l$2:
	si, ax mov   di, dx mov		\ restore Forth registers
	bx pop
	next,
End-Code


Code Cmove>(s)l	( segment source destination len -- )
\	bx pop			        \ get length
	cx, bx mov		        \ set length
	ax, si mov   dx, di mov	        \ save Forth registers
	di pop   si pop   es pop	\ get parameters
	l$2 jcxz
	cx dec   di, cx add   si, cx add        \ High > Low move
	cx inc   std

l$1:
	rep es: movsb   cld

l$2:
	si, ax mov   di, dx mov
	bx pop
	next,
End-Code




\ V-Find(s) .. J Lee -- 26/6/90
\

hex



\ temporary variable
variable Thread-Hash	\ Thread-Hash remains same, since all chunks
			\ have the same header format and same #Threads(s).



Code V-Find(s)                        \ $addr voc-chunk --
      				      \ seg cfa 1 | seg cfa -1 | $addr 0
\  bx pop                              
  es, bx mov			      \ get voc-chunk into ES	
  dx pop       		              \ get parameters
  ax pop  ds, ax mov                  \ set data segment of string
  si push  di push                    \ save Forth registers
  bx, bx or   l$5 jz		      \ leave if chunk segment == 0
  si, dx mov  	                      \ initialise pointers
  bh, bh sub                          \ accumulate into BX
  bl, 0 [si] mov  bl, 1 [si] add      \ add count & first byte
  bh, # 0 adc                         \ into BX
  cx, # #Threads(s) 1- mov            \ get #threads
  bx, cx and   bx, # 1 shl     	      \ mask, form thread offset
  di, # Chunk-Threads mov             \ point to first thread
  bx, di add                          \ point to correct thread
  cs: Thread-Hash bx mov              \ preserve table thread
 
l$6:
  es: di, 0 [bx] mov                  \ get top nfa,
  di, di or   l$3 jz		      \ leave if end of thread chain
  ch, ch sub                          \ zero high part of count
                                      \
l$1:
  si, dx mov  bx, di mov              \ text, nfa saved
  lodsw  cl, al mov                   \ get text,
  es: ax, 0 [di] xor                  \ and mask
  ax, # 07f3f and  l$2 jnz            \ remove bits, fail nz
  di inc  di inc                      \ step over count & first
  cx dec  l$4 jz                      \ success of 1-char name
  repz cmpsb  l$4 jz                  \ compare rest of name
                                      \
l$2:
  es: di, -2 [bx] mov  di, di or      \ pick up thread link
  l$1 jnz
                                      \
l$3:
  bx, # Chunk-Link mov		      \ set offset to <Chunk-Link (=Chunk-Link)
  es: bx, 0 [bx] mov		      \ get previous chunk's segment
  bx, bx or   l$5 jz		      \ leave if end of backward chunk chain
  es, bx mov			      \ set new chunk segment to search
  cs: bx, Thread-Hash mov	      \ reload thread table hash code address
  l$6 jmp			      \ go back and search new chunk

l$4:
  di inc  di inc  dx, di mov          \ point past status word
  es: 0 [bx], # 040 byte test         \ test for immediate word
  bx, # 1 mov                         \ assume normal word
  nz, If,  bx neg Endif,              \ if immediate then -1
  di pop   si pop		      \ restore Forth registers
  es push   dx push		      \ -- Seg, Symbol, Flag
  ax, cs mov  ds, ax mov              \ reset DS
\  bx push
  next,

l$5:
  di pop  si pop                      \ restore Forth registers
  dx push			      \ -- $addr flag
  ax, cs mov  ds, ax mov              \ reset DS
\  bx push
  next,                               \

End-Code




\ ?Symbol-Space .. J Lee -- 01/08/90
\


hex

\ Only here because it is a code definition	(form over function)
\
Code ?Symbol-Space	( -- memsize ; in paragraphs )
	bx push
	bx, # -1 mov
	ah, # 048 mov
	021 int
	next,
End-Code



                        
\ Fill(s) .. J Lee -- 01/08/90
\


: Fill(s)	( addr len b -- )
	rot voc-seg@ swap 2swap fill(s)l  ;




\ Cmove(s) Cmove>(s) .. J Lee -- 02/07/90
\


: Cmove(s)	( source destination len -- )
	rot voc-seg@ swap 2swap cmove(s)l  ;



: Cmove>(s)	( source destination len -- )
	rot voc-seg@ swap 2swap cmove>(s)l  ;




\ !(s) @(s) c!(s) c@(s) 2!(s) 2@(s) .. J Lee -- 02/07/90
\


: !(s)	( n offset -- )
	voc-seg@ latest-chunk @(p)l swap !l  ;

 
: @(s)	( offset -- n )
	voc-seg@ latest-chunk @(p)l swap @l  ;


: c!(s)	( c offset -- )
	voc-seg@ latest-chunk @(p)l swap c!l  ;


: c@(s)	( offset -- c )
	voc-seg@ latest-chunk @(p)l swap c@l  ;


: 2!(s)	( d offset -- )
	voc-seg@ latest-chunk @(p)l swap 2!l  ;


: 2@(s)	( offset -- d )
	voc-seg@ latest-chunk @(p)l swap 2@l  ;




\ !(s)l @(s)l c!(s)l c@(s)l 2!(s)l 2@(s)l .. J Lee -- 02/07/90
\


: !(s)l	( n seg offset -- )
	!l  ;


: @(s)l	( seg offset -- n )
	@l  ;


: c!(s)l	( c seg offset -- )
	c!l  ;


: c@(s)l	( seg offset -- c )
	c@l  ;


: 2!(s)l	( d seg offset -- )
	2!l  ;


: 2@(s)l	( seg offset -- d )
	2@l  ;




\ Erase(s) Erase(s)l Blank(s) .. Jon 26/2/90
\


: Erase(s)	( start len -- )
  0 fill(s)  ;


: Erase(s)l	( seg start len )
  0 fill(s)l  ;


: Blank(s)	( start len -- )
  bl fill(s)  ;




\ On(s) Off(s) +!(s) .. J Lee -- 26/6/90
\


: On(s)	( offset -- )
    -1 swap !(s)  ;


: Off(s)	( offset -- )
    0 swap !(s)  ;


: +!(s)	( n offset -- )
    dup c@(s)  rot +  swap c!(s)  ;




\ Count(s) Type(s) Count(s)l Type(s)l Set-Bit(s) .. J Lee -- 26/6/90
\


: Count(s)	( $offset -- offset len )
  dup 1+  swap c@(s)  ;


: Type(s)	( offset n -- )
  0
  ?Do
	dup c@(s) emit  1+
  Loop
  drop  ;


: Count(s)l	( seg $offset -- seg offset len )
  count-l  ;


: Type(s)l	( seg offset n -- )
  type-l  ;


: Set-Bit(s)	( n seg offset -- )
	2dup c@(s)l
	>r rot r>  or
	-rot c!(s)l  ;


