((

	XC-SYMBL.FTH

	J Lee :- 22/6/90

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This code creates and maintains symbols in the symbol table.

))




only forth also c-c definitions
decimal


decimal  all from-file sym-data.fth     \ symbol data structures




\ .Name(s) N>Link(s) Name>(s) .. Jon 10/08/88
\

decimal

: .Name(s)	( seg $offset -- )
  count(s)l 31 and type(s)l  ;


: N>Link(s)	( seg nfa -- seg lfa )
  cell(s)-  ;	\ use thread-links only (single threaded)


: Name>(s)	( seg nfa -- seg status-field )
  2dup c@(s)l 31 and + 1+  ;




\ >Name(s) Last'(s)@ .. Jon 09/08/88
\


: >Name(s)	( seg sym-val-fld -- seg sym-nfa )
  cell(s)-
  Begin
    1- 2dup c@(s)l 128 and 0<>
  Until  ;


: Last'(s)@	( -- addr )
  latest-chunk @(v) Last(s) @(c)  name>(s) cell(s)+  nip  ;




\ Here(s) ,(s) c,(s) 2,(s) .. Jon 28/07/88
\


: Here(s)	( -- addr )
  dp(s) @(c)  ;


: ,(s)	( n -- )
  dp(s) @(c) !(s)
  cell(s) dp(s) +!(c)  ;


: C,(s)	( c -- )
  dp(s) @(c) c!(s)
  1 dp(s) +!(c)  ;


: 2,(s)	( d -- )
	here(s) 2!(s)
	dcell(s) dp(s) +!(c)  ;




\ Allot(s) Align-Word(s) .. Jon 21/07/88
\


: Allot(s)	( n -- )
  Dp(s) +!(c)  ;


\
\ : Align-Word(s)                       \ --
\  here(s) 1 and                       \ **need to modify count**
\  If  1 allot(s) Endif                \
\ ;                                     \




\ Zero,(s) Zeros,(s) .. Jon 21/07/88
\


: Zero,(s)	( -- )
  0 ,(s)  ;


: Zeros,(s)	( n -- )
  0
  ?Do
	zero,(s)
  Loop  ;




\ Build-Dummy-Voc Init-Dp(s) .. Jon 20/07/88
\


: Init-Dp(s)	( -- )
  {Symbol-Space Dp(s) !(v)  ;		\ To start of symbol space




\ Text>Here Text>Dp(s) Set-High-Bit(s) Smudge(s) .. Jon 29/1/91
\


decimal

: Text>Here  ( seg $addr -- ; copy string to HERE for this module )
  2dup c@l 1+  cs> here  rot cmovel  ;


: Text>Dp(s)	( seg $addr -- )
  2dup c@l 31 and 1+ 0
  ?Do
    2dup c@l  c,(s)  1+ \ move to here(s)
  Loop
  2drop  ;

 
: Set-High-Bit(s)	( addr -- )
  dup c@(s)  128 or  swap c!(s)  ;


hex

: Smudge(s)	(( sym-addr(d) -- ))
	>name(s)
	2dup c@(s)l
	020 xor
	-rot c!(s)l  ;

decimal





\ Find(t) .. Jon 26/08/88
\


: Find(t)	( seg addr1 -- addr2 n | 0 )
        text>here               \ copy string into this module at HERE
	here dup c@
	If
		0  Context(s) Vsize(s) bounds
		Do
			drop i 2@(p) 2dup  or
			If
				voc-chunk+ @(s)l Latest-Chunk @(p)l
                                cs> -rot v-find(s) dup
				If
					leave		\ -- seg offset TRUE
				Endif
			Else
				or		\ leave FALSE on stack (must be 0)
			Endif
			dcell(s)
		+Loop
		dup 0=	If  nip  Endif
	Else
		drop 0
	Endif  ;




\ Search .. Jon 14/10/88
\


: (Search)	( seg $addr -- sym-addr )
  find(t)		\ look for symbol name
  0= 0 ?error  ;	\ error if can't find it




\ Header(s) .. Jon 09/08/88
\

decimal

: Header(s)	( seg $addr -- )
  2dup c@l 31 and >r 2dup 1+ c@l r>  +	\ add count + first letter
  -rot >r >r                            \ preserve seg off
  Chunk-Threads				\ to Symbol threads
  #threads(s) 1- rot and cell(s)*  +	\ calc offset thread
  dup @(s) ,(s)				\ lay thread link
  here(s) swap !(s)			\ update thread pointer
  here(s) last(s) !(c)			\ update last symbol
  here(s) r> r>                         \ retrieve seg off of $ 
  text>dp(s) set-high-bit(s)		\ copy text to symbol seg.
\ align-word(s)
  zero,(s)  ;				\ lay zero status word




\ $Create(s) Create(s) .. Jon 09/08/88
\


: $Create(s)	( seg $addr -- )
  Chunk-space? not
  If
	get-chunk link-chunk
  Endif
  header(s)  ;

	
: Create(s)	( -- ; < word name > )
  bl word dup count upper
  $create(s)  ;




\ Mark-As .. Jon 27/07/88
\


: Mark-As	(( status-field(d) bit -- ))
	>r
	2dup @(s)l
	r> or
	-rot !(s)l  ;




\ Mark-Immediate Mark-Smudged Mark-Run-Time .. Jon 27/07/88
\


: Mark-Immediate	(( status-field(d) -- ))
  Immediate-Bit mark-as  ;


: Mark-Smudged	(( status-field(d) -- ))
  Smudge-Bit mark-as  ;


: Mark-Run-Time	(( status-field(d) -- ))
  Run-Time-Bit mark-as  ;



\ Mark-Resolved Mark-Voc Mark-Def-Word Mark-C/V .. Jon 27/07/88
\


: Mark-Resolved	(( status-field(d) -- ))
  Resolved-Bit mark-as  ;


: Mark-Voc	(( status-field(d) -- ))
  Voc-Bit mark-as  ;


: Mark-Def-Word	(( status-field(d) -- ))
  Def-Word-Bit mark-as  ;


: Mark-C/V	(( status-field(d) -- ))
  C/V-Bit mark-as  ;

\ Is-Immediate Is-Smudged Is-Run-Time ...          Jon 27/07/88
\


: Is-Immediate	( -- ) 
	Latest-Chunk @(v) Last'(s)@ status+ mark-immediate  ;

                                  
: Is-Smudged	( -- )            
	Latest-Chunk @(v) Last'(s)@ status+ mark-smudged  ;

                                  
: Is-Run-Time	( -- )            
  	Latest-Chunk @(v) Last'(s)@ status+ mark-run-time  ;



\ Is-Resolved Is-Voc Is-Def-Word Is-C/V .. Jon 27/07/88
\


: Is-Resolved	( -- )
  	Latest-Chunk @(v) Last'(s)@ status+ mark-resolved  ;


: Is-Voc	( -- )           
  	Latest-Chunk @(v) Last'(s)@ status+ mark-voc  ;


: Is-Def-Word	( -- )           
  	Latest-Chunk @(v) Last'(s)@ status+ mark-def-word  ;


: Is-C/V	( -- )           
  	Latest-Chunk @(v) Last'(s)@ status+ mark-c/v  ;



\ (Make-Voc) .. sfp 15/08/88
\


decimal

: (Make-Voc)	( -- )
  #Threads(t) zeros,(s)				\ t-threads
  zero,(s)						\ where target is

  latest-chunk @(v) here(s)			\ address within voc symbol
  ^<voc-link(s) 2@(p)l				\ current top of voc chain
  ,(s) ,(s)						\ lay pointer 
  ^<voc-link(s) 2!(p)l				\ set current voc symbol as top

  latest-chunk @(v) here(s) 2dup		\ address within voc symbol
  ^curr->voc-link(s) 2@(p)l 2!(s)l	\ add new voc to forward chain
  ^curr->voc-link(s) 2!(p)l			\ update curr forward chain pointer
  2 zeros,(s)						\ reserve >voc-link(s) pointer

  zero,(s)						\ Voc-Chunk
  #Threads(s) zeros,(s)  ;			\ allot space for symbol threads




\ $Symbol Symbol $Def-Word Def-Word .. Jon 08/08/88
\


: $Symbol	( seg $addr -- )
  $create(s) 3 zeros,(s)  ;


: Symbol	( -- )
  cs> bl word dup count upper $symbol  ;


: $Def-Word	( seg $addr -- )
  $symbol is-def-word                 \ Mark status as a
  3 zeros,(s)  ;                      \ defining word.


: Def-Word	( -- ; <name> )
  cs> bl word dup count upper $def-word  ;




\ $Make-Voc Make-Voc $Make-C/V .. Jon 09/08/88
\


: $Make-Voc	( seg $addr -- )
  $Symbol is-voc (make-voc)  ;


: Make-Voc	( -- ; <name> )
  cs> bl word dup count upper             \
  $make-voc  ;                        \ mark status as a


: $Make-C/V	( n seg $addr -- )
  $symbol is-c/v					\ Mark status as c/v
  voc-seg@  here(s)  dup dcell(s)-  2!(s)	\ set pointer to data
  dup ,(s)		 			   		\ Lay size,
  dup here(s) -rot allot(s) erase(s)  ;   	\ allot zeroed space.




\ Make-C/V make-C/V-Data-Packet .. Jon 08/08/88
\


: Make-C/V	( n -- ; <name> )
  cs> bl word dup count upper
  $make-c/v  ;
: Lay-pointer		( -- )
  latest-chunk @(v) here(s) 'latest(s) 2@(v) 
  cell(s)+ 2!(s)l			\ Point to data packet
;

: Latest-as-c/v		( -- )
  'latest(s) 2@(v) status+ mark-c/v	\ mark as a c/v
;

: Make-C/V-Data-Packet	( n -- )
  Lay-pointer				\
  2 ,(s)				\ lay #bytes of data
  ,(s)					\ lay data packet
  Latest-as-c/v				\
;
  
: Make-Double-Data-Packet	( n1 n2 -- )
  Lay-pointer				\
  4 ,(s)				\ lay #bytes of data
  ,(s) ,(s)				\ lay data packet
  Latest-as-c/v				\
;

: Make-Float-Data-Packet	( n1 n2 n3 -- )
  Lay-pointer				\
  6 ,(s)				\ lay #bytes of data
  ,(s) ,(s) ,(s)			\ lay data packet
  Latest-as-c/v				\
;

\ Reset-Threads(s) ......................          Jon 10/10/88
\


: Reset-Threads(s)	( -- ; reset threads for VOC-SEG )
	chunk-threads			\ offset into header for threads
	#Threads(s) 0			\ for number of threads:
	?Do
		0 over !(v)		\ 	reset thread
		cell(s)+			\	move to next thread
	Loop
	drop	;				\ the thread address


















