((

	MEMDRVL.FTH
	Memory driver for little-endian targets

	MPE Forth Cross Compiler v5.00

	J Lee - 10/7/90
                19/2/91


	Copyright (c) 1983-1990

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)
	fax: (+44) 703 339691

))



only forth also c-c definitions
decimal




\ Memory drivers .. sfp 18/01/90
\


Defer @(T)	\ fetch from target
Defer !(T)	\ store to target
Defer ,(T)	\ comma into target dictionary
Defer ,(R)	\ comma into target RAM
Defer W@(T)	\ word (16-bit) fetch
Defer W!(T)	\ word (16-bit) store
Defer W@(O)	\ word (16-bit) fetch
Defer W!(O)	\ word (16-bit) store
Defer L@(O)	\ long word (32-bit) fetch
Defer L!(O)	\ long word (32-bit) store

Defer c!(o)
Defer c@(o)
Defer c@(t)
Defer c!(t)
Defer c,(r)




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


\
\ The 65xx family uses lo-byte first (lo. byte at lo. address)
\

create split-buff	4 allot

: C!(d)	( b -- )
  D-Addr i.blk + c!
  i.upd  ;


: C@(d)	( -- b )
  D-Addr i.blk + c@  ;

\ Memory Reference .. J Lee -- 19/2/91
\


: (C@(t))	( addr -- b )
	?inram
	If
		Ram-Area @(g) swap c@l
	Else
		c@(o)
	Endif  ;


: (C!(t))	( b addr -- )
	?inram
	If
		Ram-Area @(g) swap c!l
	Else
		c!(o)
	Endif  ;

\ Memory reference .. J Lee -- 19/2/91
\

hex
: Ita  ( -- seg addr ; returns 1st free space in init. RAM table )
  Ram-Area @(g) Curr-Ram-Size @(g)  ;

: (C,(r))	( b -- )
  ita c!l
  1 allot-ram  ;

\ Memory reference .. J Lee -- 19/2/91

: w@(d)	( addr -- n )
	dup c@(d)  split-buff c!
	1+ c@(d)  split-buff 1+ c!
	split-buff @  ;


: w!(d)	( n addr -- )
	swap split-buff !
	split-buff c@  over c!(d)
	split-buff 1+ c@  swap 1+ c!(d)  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


\
\ long linear addresses are meaningless on a 8086, but they are
\ implemented for 2@ and 2!
\


: l@(d)	( addr -- d ; fetch double number )
	dup 2+ w@(d)  swap w@(d)  ;


: l!(d)	( d addr -- ; store double number )
	>r  r@ w!(d)  r> 2+ w!(d)  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


(

\ Assume that double words are stored in memory order,
\ EXCEPT that the byte order in each 16-bit word is exchanged

: 2flip         \ n1 n2 -- n1' n2' ; byte reverse both words
  flip swap flip swap  ;

)




\ Memory Reference - 8086 > little-endian .. J Lee -- 19/2/91
\


: (W!(t))	( n addr -- )
	?inram
	If
		Ram-Area @(g) swap !l
	Else
		w!(o)
	Endif  ;

3 Constant Float-cells			\ size of float in cells
Float-cells cell * Constant Float-bytes \ size of float in bytes

: F!		\ float addr -- ; stores float at addr
  ?inram				\
  If					\
    Float-cells 0			\ store three integers
    do					\
      >r				\ save address
      Ram-Area @(g) r@ !l		\
      r> cell+				\ restore address
    loop				\
    drop				\
\  Else					\
\    w!(o)				\
  Endif 				\
;


: F@		\ addr -- float ; return float at addr
  ?inram				\
  If					\
    Float-bytes	+ cell-			\ move to high word
    Float-cells 0			\ store three integers
    do					\
      >r				\ save address
      Ram-Area @(g) r@ @l		\
      r> cell-				\ restore address
    loop				\
    drop				\
\  Else					\
\    w!(o)				\
  Endif 				\
;


: L!(t)	( d addr -- )
	?inram
	If
		Ram-Area @(g) swap 2!l
	Else
		l!(o)
	Endif  ;


: (W@(t))	( addr -- n )
	?inram
	If
		Ram-Area @(g) swap @l
	Else
		w@(o)
	Endif  ;


: L@(t)	( addr -- d )
	?inram
	If
		Ram-Area @(g) swap 2@l
	Else
		l@(o)
	Endif  ;


: +!(t)	( n addr -- )
	>r  r@ w@(t) +  r> w!(t)  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


: L,(t)	( d -- )
	here(t) l!(t)  4 Dp(t) +!(p)  ;


: W,(t)	( n -- )
	here(t) w!(t)  2 Dp(t) +!(p)  ;


: C,(t)	( b -- )
	here(t) c!(t)  1 Dp(t) +!(p)  ;




\ Memory reference - 8086 > little-endian .. J Lee -- 19/2/91
\


: W,(r)	( n -- ; comma into initialised RAM area )
	ita !l  2 allot-ram  ;


: L,(r)	( d -- ; comma into initialised RAM area )
	ita 2!l  4 allot-ram  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\

Assign w@(d) to-do w@(o)	\ disk is output device
Assign w!(d) to-do w!(o)	\  "	"   "	   "
Assign (w!(t)) to-do w!(t)
Assign (w@(t)) to-do w@(t)
Assign w@(t) to-do @(t)
Assign w!(t) to-do !(t)
Assign w,(t) to-do ,(t)
Assign w,(r) to-do ,(r)

Assign C!(D) to-do C!(O)
Assign C@(D) to-do C@(O)
Assign (C@(T)) to-do C@(T)
Assign (C!(T)) to-do C!(T)
Assign (c,(r)) to-do c,(r)




\ Memory reference - 8086 > 8086 .. sfp 18/01/90
\


2 constant cell(t)	\ size of 8086 cell

: >body(t)	( cfa -- pfa ; add size of call xxxx )
	3 +  ;		\ JUMP/CALL is 3 bytes


\ >CA(T) converts a target CFA to the number that is compiled.
\ For most processors the compilation address is the CFA itself,
\ but on an RTX it is CFA >>1

: >ca(t)	( cfa -- compilation-address )
  ;




















