((

	XC-PRIMS.FTH

	J Lee :- 1/8/90

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This code performs primitive operations.

	IMPORTANT !!!
	V-FIND(S) uses two header offsets. These are defined in HEADER.FTH
	and occur as forward references in this file. To overcome this problem
	the header offsets are defined in this file as well. Care should be
	taken to ensure that the header offsets in both this file and HEADER.FTH
	correspond. There is also a constant ( #THREADS(S) ) which can also be
	found in HEADER.FTH.

))



only forth definitions
decimal

." Finishedvdbshjb" key drop

\ Fill(s)l Cmove(s)l Cmove>(s)l .. J Lee -- 02/07/90
\


Code Fill(s)l		( seg offset len b -- )
\	bx pop
	al, bl mov		\ save byte
	dx, di mov   cx pop   di pop
	l$1 jcxz
	es pop
	rep stosb

l$1:
	di, dx mov
	bx pop
	next,
End-Code


Code Cmove(s)l	( seg source destination len -- )
\	bx pop			\ get length
	cx, bx mov		\ set length
	ax, si mov   dx, di mov		\ save Forth registers
	di pop   si pop   es pop		\ get parameters
	l$2 jcxz

l$1:
	rep es: movsb

l$2:
	si, ax mov   di, dx mov		\ restore Forth registers
	bx pop
	next,
End-Code


Code Cmove>(s)l	( segment source destination len -- )
\	bx pop			\ get length
	cx, bx mov		\ set length
	ax, si mov   dx, di mov		\ save Forth registers
	di pop   si pop   es pop		\ get parameters
	l$2 jcxz
	cx dec   di, cx add   si, cx add	\ High > Low move
	cx inc   std

l$1:
	rep es: movsb   cld

l$2:
	si, ax mov   di, dx mov
	bx pop
	next,
End-Code




\ 3Dup 2Rot .. J Lee -- 14/07/90
\


decimal

Code 3Dup	( n1 n2 n3 -- n1 n2 n3 n1 n2 n3 )
\	bx pop
	ax pop   cx pop
	cx push   ax push   bx push
	cx push   ax push
\	bx push
	next,
End-Code


\ Modforth2 version
\
\ Code 2Rot	( d1 d2 d3 -- d2 d3 d1 )
\	cx, bp mov						\ preserve BP
\	ax, sp mov   bp, ax mov				\ set BP := SP
\	bx, [bp] 8 mov   ax, [bp] 10 mov		\ grab d1
\	ax push   bx push					\ push d1
\	bx, [bp] 4 mov   ax, [bp] 6 mov		\ grab d2
\	8 [bp], bx mov   10 [bp], ax mov		\ shuffle down d2
\	bx, [bp] 0 mov   ax, [bp] 2 mov		\ grab d3
\	4 [bp], bx mov   6 [bp], ax mov		\ shuffle d3
\	bx pop   ax pop					\ pop d1
\	0 [bp], bx mov   2 [bp], ax mov		\ rewrite d1
\	bp, cx mov						\ restore BP
\	next,
\ End-Code



\ Modforth3 version
\

Code 2Rot	( d1 d2 d3 -- d2 d3 d1 )
	bx push
	cx, bp mov						\ preserve BP
	ax, sp mov   bp, ax mov				\ set BP := SP
	bx, [bp] 8 mov   ax, [bp] 10 mov		\ grab d1
	ax push   bx push					\ push d1
	bx, [bp] 4 mov   ax, [bp] 6 mov		\ grab d2
	8 [bp], bx mov   10 [bp], ax mov		\ shuffle down d2
	bx, [bp] 0 mov   ax, [bp] 2 mov		\ grab d3
	4 [bp], bx mov   6 [bp], ax mov		\ shuffle d3
	bx pop   ax pop					\ pop d1
	0 [bp], bx mov   2 [bp], ax mov		\ rewrite d1
	bp, cx mov						\ restore BP
	bx pop
	next,
End-Code


." Finishedvdbshjb" key drop


\ ?Symbol-Space .. J Lee -- 01/08/90
\


hex

\ Only here because it is a code definition	(form over function)
\
Code ?Symbol-Space	( -- memsize ; in paragraphs )
	bx push
	bx, # -1 mov
	ah, # 048 mov
	021 int
	next,
End-Code




\ V-Find(s) .. J Lee -- 26/6/90
\

hex



\ Fake header offsets & constants .. J Lee 1/8/90
\


010 constant #Threads(s)
000 constant <Chunk-Link
006 constant Chunk-Threads



\ temporary variable
variable Thread-Hash	\ Thread-Hash remains same, since all chunks
					\ have the same header format and same #Threads(s).



Code V-Find(s)                        \ $addr voc-chunk --
							    \ seg cfa 1 | seg cfa -1 | $addr 0
\  bx pop                              
  es, bx mov					    \ get voc-chunk into ES	
  dx pop       		              \ get parameters
  si push  di push                    \ save Forth registers
  bx, bx or   l$5 jz			    \ leave if chunk segment == 0
  si, dx mov  	                   \ initialise pointers
  bh, bh sub                          \ accumulate into BX
  bl, 0 [si] mov  bl, 1 [si] add      \ add count & first byte
  bh, # 0 adc                         \ into BX
  cx, # #Threads(s) 1- mov            \ get #threads
  bx, cx and   bx, # 1 shl     	    \ mask, form thread offset
  di, # Chunk-Threads mov             \ point to first thread
  bx, di add                          \ point to correct thread
  Thread-Hash bx mov			    \ preserve table thread
 
l$6:
  es: di, 0 [bx] mov                  \ get top nfa,
  di, di or   l$3 jz			    \ leave if end of thread chain
  ch, ch sub                          \ zero high part of count
                                      \
l$1:
  si, dx mov  bx, di mov              \ text, nfa saved
  lodsw  cl, al mov                   \ get text,
  es: ax, 0 [di] xor                  \ and mask
  ax, # 07f3f and  l$2 jnz            \ remove bits, fail nz
  di inc  di inc                      \ step over count & first
  cx dec  l$4 jz                      \ success of 1-char name
  repz cmpsb  l$4 jz                  \ compare rest of name
                                      \
l$2:
  es: di, -2 [bx] mov  di, di or      \ pick up thread link
  l$1 jnz
                                      \
l$3:
  bx, # <Chunk-Link mov			    \ set offset to <Chunk-Link
  es: bx, 0 [bx] mov			    \ get previous chunk's segment
  bx, bx or   l$5 jz			    \ leave if end of backward chunk chain
  es, bx mov					    \ set new chunk segment to search
  bx, Thread-Hash mov			    \ reload thread table hash code address
  l$6 jmp					    \ go back and search new chunk

l$4:
  di inc  di inc  dx, di mov          \ point past status word
  es: 0 [bx], # 040 byte test         \ test for immediate word
  bx, # 1 mov                         \ assume normal word
  nz, If,  bx neg Endif,              \ if immediate then -1
  di pop   si pop				    \ restore Forth registers
  es push   dx push				\ -- Seg, Symbol, Flag
\  bx push
  next,

l$5:
  di pop  si pop                      \ restore Forth registers
  dx push					    \ -- $addr flag
\  bx push
  next,                               \

End-Code

decimal
 
