\ routines to exercise the HSI unit
\ frequency counting a square wave on pin HSI0

((
This code released as example code only, for use with the
80c196 cross-compiler
(c) MicroProcessor Engineering Ltd., 1991
133 Hill Lane
Southampton
SO1 5AF

Phone: (+44) 703 631441
Fax:   (+44) 703 339691

))

\ -----End of Page-----
\ -- R.G.G -- 3/12/91 --  constants and variables

hex

\ -- addr ; sfr register addresses

03 constant HSI-mode
04 constant HSI-time
06 constant HSI-status
015 constant IOC0
016 constant IOS1
013 constant int-mask1

decimal

variable periods		\ the timer count for the last period
variable counter		\ the count of ints happening

\ -----End of Page-----
\ -- R.G.G -- 3/12/91 --  init-hsi read-time

: init-hsi		\ -- ; set up the hsi system
  0 HSI-mode c!			\ set HSI0 to respond to +/-ve transitions
  ei				\ enable the interrupts
  4 int-mask1 set-bit		\ enable hsi*4 interrupt
  1 IOC0 set-bit		\ enable only HSI0 pin
;

: read-time        	\ -- time tf ; reads entry from HSI0; flag is false if
				\ no entry is present in FIFO
  HSI-status c@			\ get the current status 
  1 and				\ mask low bit 
  HSI-time @			\ get the time value 
  swap				\ place in desired order 
;

: (hsi-int)		\ -- ; the interrupt routine
  1 IOC0 reset-bit              \ enable only HSI0 pin
  1 counter +!			\ increment counter
  read-time			\ get the time of the first int
  if
    read-time			\ if an event, then get next
    if
      swap -			\ delta-t
      periods !		        \ save interval for later use
    else
      drop			\ tidy up if no second event
    endif
  else
    drop			\ if no event, then tidy up
  endif
  1 IOC0 set-bit                \ enable only HSI0 pin
;

HEX

l: hsi-int
 ] (hsi-int) reti [                     \ action, return

ASSEMBLER
l: hsi-int0                             \ registers saved by IRQ
  pushf   push ip                       \ save PSW and IP
  ld ip # hsi-int   ljmp next-int       \ load new IP
FORTH

hsi-int0 02034 !                        \ set vector


