\ LED driver code
\ This file contains a driver for 8 LEDs attached to port A of the 8255 A
\ on the digital i/o card for the MPE 80C196 PowerBoard range.

\ Copyright (C) 1992 MicroProcessor Engineering

\ MicroProcessor Engineering
\ 133 Hill Lane
\ Shirley
\ Southampton SO1 5AF
\ England

\ tel: (+44) 703 631441
\ fax: (+44) 703 339691
\ net: mpe@compulink.co.uk

\ driving the LEDs

hex

: >leds		\ n -- ; put n on the i/o port
  not 0C000 c!  ;			\ invert first

variable delay	\ -- addr ; holds delay while switching leds
  0800 delay !				\ initialise it

: gap		\ n -- ; wait a bit
  0 ?do loop  ;

: counter	\ -- ; runs counter on the LEDs
  0					\ initial value
  begin  dup >leds  1+			\ output current value and increment
	 delay @ gap			\ wait a bit
	 key?				\ pause until user presses a key
  until
  drop  ;				\ discard last value

: act1		\ -- ; counter as a task
  0					\ initial value
  begin  dup >leds  1+			\ output current value and increment
	 delay @ wait			\ wait a bit
  again  ;

init-multi multi		\ start multi-tasker
init-8255s			\ initialise 8255s on DIGIO board
assign act1 1 to-task		\ define a new task
1 activate			\ start it

