\ 8096 ROM PowerForth - Interrupt handlers

pto

Copyright (c) 1988..1991 to:

MicroProcessor Engineering Limited
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441   ( international )
tel: 0703 631441        ( domestic )

Oct 1991	Separated from multitasker code


\ normal register equates

\ 0   constant r0                 \ register 0 always returns 0
\ 018 constant SP                 \ data stack pointer
\ 01A constant RP                 \ return stack pointer
\ PLM style register set - allows mixed language programming
\ 01C constant AX         01C constant AL   01D constant AH
\ 01E constant BX         01E constant BL   01F constant BH
\ 020 constant CX         020 constant CL   021 constant CH
\ 022 constant DX         022 constant DL   023 constant DH
\ 024 constant IP                 \ Forth Interpretive pointer
\ 026 constant UP                 \ user area pointer
\ 028 constant TOS                \ top of data stack register
\   028 constant tos.l            \ NB TOS is LONG aligned
\   029 constant tos.h
\ 02A constant tosext             \ TOS extension

\ ei di save-int restore-int                       sfp 12/01/89

code ei                 \ -- ; enable interrupts
  ei   next,   end-code

code di                 \ -- ; disable interrupts
  di   next,   end-code

code save-int           \ -- n ; save interrupt status
  push tos   pushf   pop tos   di       \ save int, turn it off
  next,   end-code                      \

code restore-int        \ n -- ; restore interrupt
  push tos   popf   pop tos   next,   end-code


\ reti - return from interrupt                     sfp 05/02/89

code reti       \ return from high level interrupt
l: [hreti]
  pop TOSEXT    pop TOS                 \ stack top registers
  pop UP                                \ user area pointer
  pop DX   pop CX   pop BX   pop AX     \ scratch registers
  pop ip   popf   ret                   \ IP, flags, done
end-code


\ next-int - common interrupt handler              sfp 05/02/89

assembler
l: next-int     \ save context and restart Forth
  push AX   push BX			\ PLM register set - part 1
  push CX   push DX			\ PLM register set - part 2
					\ IP already done
  push UP				\ user area pointer
  push TOS    push TOSEXT		\ top of data stack register(s)

  ld up # int-init-u0			\ interrupt user area
					\ IP already set
  next,
forth

\ Timer overflow interrupt                         sfp 05/02/89
((
This code provides an example of a high level interrupt handler.
The high level Forth ISR word is deferred so that the user may
reassign the action at will.
))

HEX

variable tov-ticks                      \ counter

: tov-count     \ -- ; increment ticks counter
  1 tov-ticks +!  ;

: start-tov     \ -- ; setup and enable overflow interrupts
  01 int_mask set-bit			\ enable TOV interrupts INT_MASK.0
  004 ioc1 set-bit			\ enable TOV int on IOC1.2
  ei  ;                                 \ enable any interrupts

defer tov-isr				\ DEFERred word for each interrupt
  assign tov-count to-do tov-isr

l: tov-int
 ] tov-isr reti [			\ action, return

ASSEMBLER                               \
l: tov-int0                             \ registers saved by IRQ
  pushf   push ip                       \ save PSW and IP
  ld ip # tov-int   ljmp next-int       \ load new IP
FORTH

tov-int0 02000 !                        \ set vector
